import { __assign } from "tslib";
import React, { useState } from 'react';
import Portal from './Portal';
import { usePicker } from './context';
import { DropperIcon } from './icon';
import html2canvas from 'html2canvas';
import { controlBtnStyles } from './Controls';
var EyeDropper = function () {
    var handleChange = usePicker().handleChange;
    var _a = useState(''), pickerCanvas = _a[0], setPickerCanvas = _a[1];
    var _b = useState(false), coverUp = _b[0], setCoverUp = _b[1];
    var takePick = function () { return html2canvas(document.body)
        .then(function (canvas) {
        var croppedCanvas = document.createElement('canvas');
        var croppedCanvasContext = croppedCanvas.getContext('2d');
        var cropPositionTop = 0;
        var cropPositionLeft = 0;
        var cropWidth = window.innerWidth * 2;
        var cropHeight = window.innerHeight * 2;
        croppedCanvas.width = cropWidth;
        croppedCanvas.height = cropHeight;
        croppedCanvasContext.drawImage(canvas, cropPositionLeft, cropPositionTop);
        setPickerCanvas(croppedCanvasContext);
        setCoverUp(true);
    }); };
    var getEyeDrop = function (e) {
        e.stopPropagation();
        var x1 = e.clientX * 2;
        var y1 = e.clientY * 2;
        var _a = pickerCanvas.getImageData(x1, y1, 1, 1).data, r = _a[0], g = _a[1], b = _a[2];
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", 1)"));
        setCoverUp(false);
    };
    return (React.createElement("div", null,
        React.createElement("div", { style: __assign(__assign({ width: 30 }, controlBtnStyles(coverUp)), { height: 24, borderRadius: 4 }), className: 'df jc ac', onClick: takePick },
            React.createElement(DropperIcon, { color: coverUp ? '#568CF5' : '' })),
        coverUp &&
            React.createElement(Portal, { id: "eyeDropCover" },
                React.createElement("div", { style: { position: 'absolute', left: 0, top: 0, zIndex: 100000000, width: window.innerWidth, height: window.innerHeight, cursor: 'copy' }, onClick: function (e) { return getEyeDrop(e); } }))));
};
export default EyeDropper;
//# sourceMappingURL=EyeDropper.js.map