"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var Portal_1 = tslib_1.__importDefault(require("./Portal"));
var context_1 = require("./context");
var icon_1 = require("./icon");
var html2canvas_1 = tslib_1.__importDefault(require("html2canvas"));
var Controls_1 = require("./Controls");
var EyeDropper = function () {
    var handleChange = (0, context_1.usePicker)().handleChange;
    var _a = (0, react_1.useState)(''), pickerCanvas = _a[0], setPickerCanvas = _a[1];
    var _b = (0, react_1.useState)(false), coverUp = _b[0], setCoverUp = _b[1];
    var takePick = function () { return (0, html2canvas_1.default)(document.body)
        .then(function (canvas) {
        var croppedCanvas = document.createElement('canvas');
        var croppedCanvasContext = croppedCanvas.getContext('2d');
        var cropPositionTop = 0;
        var cropPositionLeft = 0;
        var cropWidth = window.innerWidth * 2;
        var cropHeight = window.innerHeight * 2;
        croppedCanvas.width = cropWidth;
        croppedCanvas.height = cropHeight;
        croppedCanvasContext.drawImage(canvas, cropPositionLeft, cropPositionTop);
        setPickerCanvas(croppedCanvasContext);
        setCoverUp(true);
    }); };
    var getEyeDrop = function (e) {
        e.stopPropagation();
        var x1 = e.clientX * 2;
        var y1 = e.clientY * 2;
        var _a = pickerCanvas.getImageData(x1, y1, 1, 1).data, r = _a[0], g = _a[1], b = _a[2];
        handleChange("rgba(".concat(r, ", ").concat(g, ", ").concat(b, ", 1)"));
        setCoverUp(false);
    };
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("div", { style: tslib_1.__assign(tslib_1.__assign({ width: 30 }, (0, Controls_1.controlBtnStyles)(coverUp)), { height: 24, borderRadius: 4 }), className: 'df jc ac', onClick: takePick },
            react_1.default.createElement(icon_1.DropperIcon, { color: coverUp ? '#568CF5' : '' })),
        coverUp &&
            react_1.default.createElement(Portal_1.default, { id: "eyeDropCover" },
                react_1.default.createElement("div", { style: { position: 'absolute', left: 0, top: 0, zIndex: 100000000, width: window.innerWidth, height: window.innerHeight, cursor: 'copy' }, onClick: function (e) { return getEyeDrop(e); } }))));
};
exports.default = EyeDropper;
//# sourceMappingURL=EyeDropper.js.map