"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var react_dom_1 = require("react-dom");
var uuid_1 = require("uuid");
var Portal = function (_a) {
    var children = _a.children;
    var id = (0, uuid_1.v4)();
    var el = (0, react_1.useRef)(document.getElementById(id) || document.createElement("div"));
    var dynamic = (0, react_1.useState)(!el.current.parentElement)[0];
    (0, react_1.useEffect)(function () {
        var refValue = el.current;
        if (dynamic) {
            el.current.id = id;
            document.body.appendChild(el.current);
        }
        return function () {
            if (dynamic && refValue.parentElement) {
                refValue.parentElement.removeChild(refValue);
            }
        };
        //eslint-disable-next-line
    }, [id]);
    return (0, react_dom_1.createPortal)(children, el.current);
};
exports.default = (0, react_1.memo)(Portal);
//# sourceMappingURL=Portal.js.map